<?php
/**
* @Virtuemart   Social Share plugin
* @version   		2.5
* @copyright   	Copyright (C) 2011-2012 Minitek. All rights reserved
* @license   		GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
* @author url   http://www.minitek.gr/
* @author email info@minitek.gr
* @developer   	minitek.gr
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

class plgSystemVmsocialshare extends JPlugin
{
	function plgVmsocialshare(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'vmsocialshare' );
		$this->_params = new JParameter( $this->_plugin->params );	
	}
	

	function onAfterDispatch(  ) {
	  $uri = & JFactory::getURI();
		$current = $uri->toString();
		// get page options
		$pageoption = JRequest::getVar( 'option', '' );
		$pageview = JRequest::getVar( 'view', '' );
		$pageid = JRequest::getVar( 'virtuemart_product_id', '' );
		
		if ($pageoption == 'com_virtuemart' && $pageview == 'productdetails' && $pageid) {	
		  $this->_setOpenGraphTags(  );	
		}	
	}	
	
		
	private function _setOpenGraphTags(  ) {	
    
		// do not display in administrator
		$mainframe = JFactory::getApplication();			
		if($mainframe->isAdmin())
		{
			return;
		}
		
		// get page options
		$pageoption = JRequest::getVar( 'option', '' );
		$pageview = JRequest::getVar( 'view', '' );
		$pageid = JRequest::getVar( 'virtuemart_product_id', '' );
		$pagecategory = JRequest::getVar( 'virtuemart_category_id', '' );
		
		if ($pageoption == 'com_virtuemart' && $pageview == 'productdetails' && $pageid) {	
		
		  if (!$pagecategory) {
		    $query = " SELECT id, virtuemart_product_id, virtuemart_category_id "
			  ." FROM #__virtuemart_product_categories "
			  ." WHERE virtuemart_product_id=".$pageid;	 
			  $db =& JFactory::getDBO();
			  $db->setQuery( $query );	
			  $row = $db->loadObject();			 
			  $pagecategory = $row->virtuemart_category_id;  
		  }
		
		  // get url
			$uri = & JFactory::getURI();
			$raw_url = $uri->toString();
		
			// Check if sef in on
			$app = JFactory::getApplication();
    	$isSef = $app->getCfg( 'sef' );
		
			if ($isSef) {		
	      $fixed_url = str_replace("?showall=1", "", $raw_url);
	      $fixed_url = str_replace("?virtuemart_product_id=".$pageid."&virtuemart_category_id=".$pagecategory."", "", $fixed_url);
				$fixed_url = str_replace("&showall=1", "", $fixed_url);
			}
			if (!$isSef) {
			  $fixed_url = str_replace("&virtuemart_category_id=".$pagecategory."", "", $raw_url);
				$fixed_url = str_replace("&virtuemart_product_id=".$pageid."", "&virtuemart_product_id=".$pageid."&virtuemart_category_id=".$pagecategory."", $fixed_url);
				$fixed_url = str_replace("&showall=1", "", $fixed_url);
			}
		
			// get page title
			$document = JFactory::getDocument();
    	$page_title = $document->getTitle();
		
			// get image
			$query = " SELECT a.id as a_id, a.virtuemart_product_id as a_pid, a.virtuemart_media_id as a_mid, b.virtuemart_media_id as b_mid, b.file_url as b_thumb "
			." FROM #__virtuemart_product_medias AS a "
			." LEFT JOIN #__virtuemart_medias AS b ON a.virtuemart_media_id=b.virtuemart_media_id "
			." WHERE a.virtuemart_product_id=".$pageid;	 
			$db =& JFactory::getDBO();
			$db->setQuery( $query );	
			$row = $db->loadObject();			 
			$this_thumb = $row->b_thumb;
			$pageURL = JURI::base();
			$image = ''.$pageURL.$this_thumb.'';
			// get description
			$query = " SELECT virtuemart_product_id as pid, product_s_desc as description "
			." FROM #__virtuemart_products_en_gb "
			." WHERE virtuemart_product_id=".$pageid;	 
			$db =& JFactory::getDBO();
			$db->setQuery( $query );	
			$row = $db->loadObject();			 
			$this_desc = $row->description;
		
			// create tags
			//$document	= & JFactory::getDocument();
			$document->setMetaData('og:image', $image);
			$document->setMetadata('og:type', $this->params->get( 'fbtype' ));
			$document->setMetadata('og:title', $page_title );
			$document->setMetadata('og:description', strip_tags($this_desc));
			$document->setMetadata('fb:admins', $this->params->get( 'fb_admin' ));	
			$document->setMetadata('og:url', $fixed_url);
					
		}
		
	}	
	
	function onAfterRender()
	{
		
		// do not display in administrator
		$mainframe = JFactory::getApplication();			
		if($mainframe->isAdmin())
		{
			return;
		}
		
		// get page options
		$pageoption = JRequest::getVar( 'option', '' );
		$pageview = JRequest::getVar( 'view', '' );
		$pageid = JRequest::getVar( 'virtuemart_product_id', '' );
		$pagecategory = JRequest::getVar( 'virtuemart_category_id', '' );
		
		if ($pageoption == 'com_virtuemart' && $pageview == 'productdetails' && $pageid) {	
		
		  if (!$pagecategory) {
		    $query = " SELECT id, virtuemart_product_id, virtuemart_category_id "
			  ." FROM #__virtuemart_product_categories "
			  ." WHERE virtuemart_product_id=".$pageid;	 
			  $db =& JFactory::getDBO();
			  $db->setQuery( $query );	
			  $row = $db->loadObject();			 
			  $pagecategory = $row->virtuemart_category_id;  
		  }
		  
		  // get url
			$uri = & JFactory::getURI();
			$raw_url = $uri->toString();
		
			// Check if sef in on
			$app = JFactory::getApplication();
    	$isSef = $app->getCfg( 'sef' );
		
			if ($isSef) {		
			  $fixed_url = str_replace("?showall=1", "", $raw_url);
	      $fixed_url = str_replace("?virtuemart_product_id=".$pageid."&virtuemart_category_id=".$pagecategory."", "", $fixed_url);
				$fixed_url = str_replace("&showall=1", "", $fixed_url);
			}
			if (!$isSef) {
		    $fixed_url = str_replace("&virtuemart_category_id=".$pagecategory."", "", $raw_url);
				$fixed_url = str_replace("&virtuemart_product_id=".$pageid."", "&virtuemart_product_id=".$pageid."&virtuemart_category_id=".$pagecategory."", $fixed_url);
				$fixed_url = str_replace("&showall=1", "", $fixed_url);
		  }
		
		  // storing body code as buffer
			$buffer = JResponse::getBody();
			
			// create content
			$content="<div style=\"".$this->params->get( 'css' )."\">";
		
			if($this->params->get( 'googleplus', '' )==1){
			  $content.='<div style="display:inline-block;margin:10px 10px 10px 0;vertical-align:top;"><g:plusone href="'.$fixed_url.'" size="'.$this->params->get( 'google_btn' ).'" count="'.$this->params->get( 'google_count' ).'"></g:plusone></div>';
		    if ($this->params->get( 'google_js' )){
			    $content.="<script type=\"text/javascript\" src=\"https://apis.google.com/js/plusone.js\">{lang: '".$this->params->get( 'google_lang' )."'}</script>";
			  }
		  }
			if($this->params->get( 'tweet', '' )==1){
			  $content.='<div style="display:inline-block;margin:10px 10px 10px 0;vertical-align:top;"><a href="http://twitter.com/share" class="twitter-share-button" data-url="'.$fixed_url.'" data-counturl="'.$fixed_url.'" data-count="'.$this->params->get( 'tweeter_btn' ).'">Tweet</a></div>';
				if ($this->params->get( 'tweeter_js' )){
			    $content.='<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>';
			  }
		  }	
			if($this->params->get( 'like', '' )==1){
		    if ($this->params->get( 'like_btn' )=='standard'){
			    $height = 27;
			  }
			  if ($this->params->get( 'like_btn' )=='button_count'){
			    $height = 20;
			  }
				if ($this->params->get( 'like_btn' )=='box_count'){
			    $height = 60;
			  }
			}
			  // add the facebook like button		
				$content.='<div style="display:inline-block;margin:10px 10px 10px 0;vertical-align:top;"><div id="fb-root"></div><script src="http://connect.facebook.net/'.$this->params->get( 'fb_lang' ).'/all.js#xfbml=1"></script><fb:like href="'.$fixed_url.'" layout="'.$this->params->get( 'like_btn' ).'" height="'.$height.'"></fb:like></div>';	 	
		  	$content.="</div>";
				
				// embed share code
				$javascript=''.$content.'';
    		$buffer = preg_replace ("/<div class=\"productdetails-view\">/", "\n\n".$javascript."\n\n<div class=\"productdetails-view\">", $buffer); 
		
		  	//replace name with property
				$buffer = preg_replace('/\<meta name=\"og\:/', '<meta property="og:', $buffer);
				$buffer = preg_replace('/\<meta name=\"fb\:/', '<meta property="fb:', $buffer);
		
		  	//output the buffer
				JResponse::setBody($buffer);	
				
				return true;	
				
		}
		
	}

}
